#****************************************************************************/
#* |\   ======   /| **              MSysM               ** |\   ======   /| */
#* |__\========/__| **     MasarLabs System Monitor     ** |__\========/__| */
#* |\            /| ** -------------------------------- ** |\            /| */
#* |  \        /  | **  Maurizio Sartori (c) 1998-2000  ** |  \        /  | */
#* |    \    /    | ** -------------------------------- ** |    \    /    | */
#* |    /=\/=\    | **            Written  by           ** |    /=\/=\    | */
#* |  /========\  | **     Maurizio Sartori 'masar'     ** |  /========\  | */
#* |/   ======   \| **   e-mail:  masar@MasarLabs.com   ** |/   ======   \| */
#****************************************************************************/
#*              This program comes with ABSOLUTELY NO WARRANTY              */
#*            for details refer to the GNU General Public License           */
#****************************************************************************/
#*\F $Id: Rules.mak,v 1.23 2000/10/01 17:26:49 cvs Exp $
#****************************************************************************/

MAKE_DEPEND := $(SRC_DIR)/Makefile \
	        $(BASE_DIR)/Makefile \
	        $(BUILD_DIR)/Custom.mak \
	        $(BUILD_DIR)/Rules.mak

OBJECTS := $(subst $(SRC_DIR),$(OBJ_DIR),$(SOURCES:.c=.o))

##############################################################################

DIR_REMOVE_CMD = \
        x=""; \
        y="$(DIR_MAKE)" ; \
        for i in $$y ; \
        do \
           x="$$i $$x"; \
        done; \
        echo $$x;

##############################################################################
# Common Rules File
##############################################################################

.PHONY: error all install clean \
	distclean dist make_tar test check dirmake

error:
	echo "ERROR: Call make from the main dir $(shell dirname `pwd`)"
	false

all: dirmake $(BUILD)

install: all

clean:
	-$(RM) $(OBJ_DIR)/* $(OBJ_DIR)/pic/* $(BUILD) > /dev/null 2>&1

distclean: clean
	-$(RMDIR) `$(DIR_REMOVE_CMD)` 2> /dev/null

dist: distclean

test: check

check:

##############################################################################

dirmake: $(DIR_MAKE)

$(DIR_MAKE):
	$(ECHO) 'MkDir   $(subst $(BASE_DIR)/,,$@)'
	$(MKDIR) $@


install_exe:
	for i in $(BUILD) ;\
        do \
	   $(PRINTF) "Install %$(SPACER)s -> %s\n" \
                     "$${i##$(BASE_DIR)/}" \
                     "$(INSTALL_BIN_DIR)/$${i##*/}" ; \
           $(MINIINST) "$$i" "$(INSTALL_BIN_DIR)/$${i##*/}" \
	               $(INSTALL_PERM_F) $(INSTALL_PERM_D) \
                       $(INSTALL_USER) $(INSTALL_GROUP) \
               >> $(LOG_DIR)/install.log || exit 1 ;\
        done

install_lib:
	for i in $(BUILD) ;\
        do \
	   $(PRINTF) "Install %$(SPACER)s -> %s\n" \
                     "$${i##$(BASE_DIR)/}" \
                     "$(INSTALL_LIB_DIR)/$${i##*/}" ; \
           $(MINIINST) "$$i" "$(INSTALL_LIB_DIR)/$${i##*/}" \
	               $(INSTALL_PERM_F) $(INSTALL_PERM_D) \
                       $(INSTALL_USER) $(INSTALL_GROUP) \
               >> $(LOG_DIR)/install.log || exit 1 ;\
        done

##############################################################################

SUFFIXES:

.SUFFIXES:

.PRECIOUS: $(OBJ_DIR)/%.d $(OBJ_DIR)/%.o $(OBJ_DIR)/pic/%.o

##############################################################################

$(OBJ_DIR)/%.d: $(SRC_DIR)/%.c $(MAKE_DEPEND)
	$(PRINTF) "Depend  %$(SPACER)s -> %s\n" \
                   "$(subst $(BASE_DIR)/,,$<)" \
                   "$(subst $(BASE_DIR)/,,$@)"
	$(MKDEP) -I $(INC_DIR) $(INCDIR) $(CFLAGS) $< | \
	        $(SED) 's#$*.o#$(OBJ_DIR)/& $(OBJ_DIR)/$*.d#g' \
	         > $@

##############################################################################

$(OBJ_DIR)/%.o: $(SRC_DIR)/%.c $(OBJ_DIR)/%.d $(MAKE_DEPEND)
	$(PRINTF) "Compile %$(SPACER)s -> %s\n" \
                   "$(subst $(BASE_DIR)/,,$<)" \
                   "$(subst $(BASE_DIR)/,,$@)"
	$(CC) -c \
               -I $(INC_DIR) $(INCDIR) $(CFLAGS) \
               -o $@ $<

##############################################################################

$(BIN_DIR)/%: $(OBJECTS)
	$(PRINTF) "Link    %$(SPACER)s -> %s\n" \
                   "$(subst $(BASE_DIR)/,,$^)" \
                   "$(subst $(BASE_DIR)/,,$@)"
	$(CC) -I $(INC_DIR) $(INCDIR) $(CFLAGS) \
               -L $(LIB_DIR) $(LIBDIR) -o $@ \
               $^ $(LIBS) $(LIBS_ADD)
	$(STRIP) $@

##############################################################################

$(LIB_DIR)/%.so: $(SRC_DIR)/%.c $(OBJ_DIR)/%.d $(MAKE_DEPEND)
	$(PRINTF) "Compile %$(SPACER)s -> %s\n" \
                   "$(subst $(BASE_DIR)/,,$<)" \
                   "$(subst $(BASE_DIR)/,,$@)"
	$(CC) -I $(INC_DIR) $(INCDIR) $(CFLAGS) $(SLFLAGS) $(SFLAFS) \
                     $(SFLAGS) $(SLFLAGS) -o $@ $<

##############################################################################

#ifeq ($(TARGET), all)
 ifneq (,$(wildcard $(OBJ_DIR)/*.d))
  include $(wildcard $(OBJ_DIR)/*.d)
 endif
#endif

##############################################################################
