/****************************************************************************/
/* |\   ======   /| **              MSysM               ** |\   ======   /| */
/* |__\========/__| **     MasarLabs System Monitor     ** |__\========/__| */
/* |\            /| ** -------------------------------- ** |\            /| */
/* |  \        /  | **  Maurizio Sartori (c) 1998-2000  ** |  \        /  | */
/* |    \    /    | ** -------------------------------- ** |    \    /    | */
/* |    /=\/=\    | **            Written  by           ** |    /=\/=\    | */
/* |  /========\  | **     Maurizio Sartori 'masar'     ** |  /========\  | */
/* |/   ======   \| **   e-mail:  masar@MasarLabs.com   ** |/   ======   \| */
/****************************************************************************/
/*              This program comes with ABSOLUTELY NO WARRANTY              */
/*            for details refer to the GNU General Public License           */
/****************************************************************************/
/*\F $Id: msysm.h,v 1.17 2000/12/16 16:06:25 cvs Exp $
*****************************************************************************/
#ifndef  _MASARLABS_MSYSM_H_
#define  _MASARLABS_MSYSM_H_

#include <msysm/modules.h>

/****************************************************************************/
/*                             Global Types                                 */
/****************************************************************************/
typedef struct _Module
   {
   struct _Module * pNext;
   void           * hDlModule;
   char           * pcszModName;
   int              iX;
   int              iY;
   unsigned int     uiWidth;
   unsigned int     uiHeight;
   void           * pModData;

   PFN_LOAD         pfnLoad;
   PFN_UNLOAD       pfnUnLoad;
   PFN_UPDATE       pfnUpdate;
   PFN_PAINT        pfnPaint;
   PFN_INFO         pfnInfo;
   PFN_EXEC         pfnExec;
   } Module;

/****************************************************************************/
/*                             Global Variables                             */
/****************************************************************************/
extern Module * p_FirstModule;

/****************************************************************************/
/*                             Global Functions                             */
/****************************************************************************/
int LoadModule (int argc, const char * argv[],
                const char * pszLibPath, int fVertical,
                Display * pDisplay, Window hWindow);

void UnLoadAllModules (Display * pDisplay, Window hWindow);

void DrawDigitString (const char *pcszStr,
                      Display * pDisplay, Window hWindow, GC hGC,
                      int iX, int iY, int iType);

void DrawLetterString (const char *pcszStr,
                       Display * pDisplay, Window hWindow, GC hGC,
                       int iX, int iY);

Pixel GetColor (const char *pszColorName, Display * pDisp, Window hWin);

/****************************************************************************/
#endif   // !defined (_MASARLABS_MSYSM_H_)
