/****************************************************************************/
/* |\   ======   /| **              MSysM               ** |\   ======   /| */
/* |__\========/__| **     MasarLabs System Monitor     ** |__\========/__| */
/* |\            /| ** -------------------------------- ** |\            /| */
/* |  \        /  | **  Maurizio Sartori (c) 1998-2000  ** |  \        /  | */
/* |    \    /    | ** -------------------------------- ** |    \    /    | */
/* |    /=\/=\    | **            Written  by           ** |    /=\/=\    | */
/* |  /========\  | **     Maurizio Sartori 'masar'     ** |  /========\  | */
/* |/   ======   \| **   e-mail:  masar@MasarLabs.com   ** |/   ======   \| */
/****************************************************************************/
/*              This program comes with ABSOLUTELY NO WARRANTY              */
/*            for details refer to the GNU General Public License           */
/****************************************************************************/
/*\F $Id: modules.h,v 1.12 2000/12/16 16:06:25 cvs Exp $
*****************************************************************************/
#ifndef  _MASARLABS_MSYSM_MODULES_H_
#define  _MASARLABS_MSYSM_MODULES_H_

#define _REENTRANT
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/xpm.h>

#include <msysm/version.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef struct _XpmIcon
   {
   Pixmap pixmap;
   Pixmap mask;
   XpmAttributes attributes;
   } XpmIcon;

typedef void *       (* PFN_LOAD)   (int argc,
                                     const char * argv[],
                                     Display * pDisplay,
                                     Window    hWindow);
typedef void         (* PFN_UNLOAD) (void    * pModData,
                                     Display * pDisplay,
                                     Window    hWindow);
typedef int          (* PFN_UPDATE) (void    * pModData);
typedef void         (* PFN_PAINT)  (Display * pDisplay,
                                     Window    hWindow,
                                     GC        hGC,
                                     int       iX,
                                     int       iY,
                                     void    * pModData);
typedef const char * (* PFN_INFO)   (void    * pModData);
typedef void         (* PFN_EXEC)   (void    * pModData);


void *       Load   (int argc,
                     const char * argv[],
                     Display * pDisplay,
                     Window    hWindow);
void         UnLoad (void    * pModData,
                     Display * pDisplay,
                     Window    hWindow);
int          Update (void    * pModData);
void         Paint  (Display * pDisplay,
                     Window    hWindow,
                     GC        hGC,
                     int       iX,
                     int       iY,
                     void    * pModData);
const char * Info   (void    * pModData);
void         Exec   (void    * pModData);

void DrawDigitString (const char *pcszStr,
                      Display * pDisplay,
                      Window hWindow,
                      GC hGC,
                      int iX,
                      int iY,
                      int iType);

void DrawLetterString (const char *pcszStr,
                       Display * pDisplay,
                       Window hWindow,
                       GC hGC,
                       int iX,
                       int iY);

Pixel GetColor (const char *pszColorName,
                Display * pDisp,
                Window hWin);

void ReadLong (const char **pBuffer,
               long * lVal);

#ifdef __cplusplus
}
#endif

/****************************************************************************/
#endif // !defined (_MASARLABS_MSYSM_MODULES_H_)
