/****************************************************************************/
/* |\   ======   /| **              MSysM               ** |\   ======   /| */
/* |__\========/__| **     MasarLabs System Monitor     ** |__\========/__| */
/* |\            /| ** -------------------------------- ** |\            /| */
/* |  \        /  | **  Maurizio Sartori (c) 1998-2000  ** |  \        /  | */
/* |    \    /    | ** -------------------------------- ** |    \    /    | */
/* |    /=\/=\    | **            Written  by           ** |    /=\/=\    | */
/* |  /========\  | **     Maurizio Sartori 'masar'     ** |  /========\  | */
/* |/   ======   \| **   e-mail:  masar@MasarLabs.com   ** |/   ======   \| */
/****************************************************************************/
/*              This program comes with ABSOLUTELY NO WARRANTY              */
/*            for details refer to the GNU General Public License           */
/****************************************************************************/
/*\F $Id: draw.c,v 1.10 2000/07/20 15:41:22 cvs Exp $
*****************************************************************************/

static char Psz_RCS [] =
    "$Id: draw.c,v 1.10 2000/07/20 15:41:22 cvs Exp $";

/****************************************************************************/

#include "msysm.h"
#include <msysm/modules.h>

#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <dlfcn.h>

/****************************************************************************/
/*                          DrawDigitString ()                              */
/****************************************************************************/
void DrawDigitString (const char *pcszStr,
                      Display * pDisplay, Window hWindow, GC hGC,
                      int iX, int iY, int iType)
   {
   #include "../xpm/dataDigitsSmall.xpm"
   #include "../xpm/dataDigitsMed.xpm"
   #include "../xpm/dataDigitsLarge.xpm"
   #include "../xpm/dataDigitsXLarge.xpm"
   static XpmIcon xpm_DigitsSmall;
   static XpmIcon xpm_DigitsMed;
   static XpmIcon xpm_DigitsLarge;
   static XpmIcon xpm_DigitsXLarge;

   XpmIcon * pXpm;
   int iWidth;
   int iHeight;
   int iIncr;

   *Psz_RCS = *Psz_RCS;                 // To fake compiler warnings

   if (pcszStr == NULL)
      {
      return;
      }

   if (xpm_DigitsSmall.pixmap == 0)
      {
      xpm_DigitsSmall.attributes.valuemask = (XpmReturnPixels |
                                              XpmReturnExtensions);
      XpmCreatePixmapFromData (pDisplay, hWindow,
                               (char **) dataDigitsSmall_xpm,
                               &xpm_DigitsSmall.pixmap, &xpm_DigitsSmall.mask,
                               &xpm_DigitsSmall.attributes);
      xpm_DigitsMed.attributes.valuemask = (XpmReturnPixels |
                                            XpmReturnExtensions);
      XpmCreatePixmapFromData (pDisplay, hWindow,
                               (char **) dataDigitsMed_xpm,
                               &xpm_DigitsMed.pixmap, &xpm_DigitsMed.mask,
                               &xpm_DigitsMed.attributes);
      xpm_DigitsLarge.attributes.valuemask = (XpmReturnPixels |
                                              XpmReturnExtensions);
      XpmCreatePixmapFromData (pDisplay, hWindow,
                               (char **) dataDigitsLarge_xpm,
                               &xpm_DigitsLarge.pixmap, &xpm_DigitsLarge.mask,
                               &xpm_DigitsLarge.attributes);
      xpm_DigitsXLarge.attributes.valuemask = (XpmReturnPixels |
                                               XpmReturnExtensions);
      XpmCreatePixmapFromData (pDisplay, hWindow,
                               (char **) dataDigitsXLarge_xpm,
                               &xpm_DigitsXLarge.pixmap, &xpm_DigitsXLarge.mask,
                               &xpm_DigitsXLarge.attributes);
      }
   switch (iType)
      {
      case 3:
         {
         pXpm    = &xpm_DigitsXLarge;
         iWidth  = 11;
         iHeight = 18;
         iIncr   = 11;
         }
      break;

      case 2:
         {
         pXpm    = &xpm_DigitsLarge;
         iWidth  = 9;
         iHeight = 15;
         iIncr   = 9;
         }
      break;

      case 1:
         {
         pXpm    = &xpm_DigitsMed;
         iWidth  = 7;
         iHeight = 11;
         iIncr   = 7;
         }
      break;

      default:
         {
         pXpm    = &xpm_DigitsSmall;
         iWidth  = 5;
         iHeight = 9;
         iIncr   = 5;
         }
      }

   while (*pcszStr)
      {
      XCopyArea (pDisplay, pXpm->pixmap, hWindow, hGC,
                 ((*pcszStr >= '0') && (*pcszStr <= '9')) ?
                    (iWidth * (*pcszStr - '0')): iWidth * 10, 0,
                 (unsigned) iIncr, (unsigned) iHeight, iX, iY);
      iX += iIncr;
      pcszStr++;
      }
   }

/****************************************************************************/
/*                          DrawLetterString ()                             */
/****************************************************************************/
void DrawLetterString (const char *pcszStr,
                       Display * pDisplay, Window hWindow, GC hGC,
                       int iX, int iY)
   {
   #include "../xpm/dataLetters.xpm"
   static XpmIcon xpm_Letters;

   int iXOrg = iX;
   char ch;

   if (pcszStr == NULL)
      {
      return;
      }

   if (xpm_Letters.pixmap == 0)
      {
      xpm_Letters.attributes.valuemask = (XpmReturnPixels |
                                          XpmReturnExtensions);
      XpmCreatePixmapFromData (pDisplay, hWindow,
                               (char **) dataLetters_xpm,
                               &xpm_Letters.pixmap, &xpm_Letters.mask,
                               &xpm_Letters.attributes);
      }

   while (*pcszStr)
      {
      if (*pcszStr == '\n')
         {
         iX  = iXOrg;
         iY += 10;
         }
      else if ((*pcszStr >= ' ') && (*pcszStr <= '~'))
         {
         ch = *pcszStr - ' ';
         XCopyArea (pDisplay, xpm_Letters.pixmap, hWindow, hGC,
                    ((ch % 16) * 6), ((ch / 16) * 10),
                    7, 10, iX, iY);
         iX += 6;
         }
      else
         {
         XCopyArea (pDisplay, xpm_Letters.pixmap, hWindow, hGC,
                    1, 1, 7, 10, iX, iY);
         iX += 6;
         }
      pcszStr++;
      }
   }

/****************************************************************************/
/*                              GetColor ()                                 */
/****************************************************************************/
Pixel GetColor (const char *pszColorName, Display * pDisp, Window hWin)
   {
   XColor xColor;
   XWindowAttributes winAttr;

   XGetWindowAttributes (pDisp, hWin, &winAttr);

   xColor.pixel = 0;

   if (XParseColor (pDisp, winAttr.colormap, pszColorName, &xColor))
      {
      XAllocColor (pDisp, winAttr.colormap, &xColor);
      }

   return xColor.pixel;
   }

