/****************************************************************************/
/* |\   ======   /| **              MSysM               ** |\   ======   /| */
/* |__\========/__| **     MasarLabs System Monitor     ** |__\========/__| */
/* |\            /| ** -------------------------------- ** |\            /| */
/* |  \        /  | **  Maurizio Sartori (c) 1998-2000  ** |  \        /  | */
/* |    \    /    | ** -------------------------------- ** |    \    /    | */
/* |    /=\/=\    | **            Written  by           ** |    /=\/=\    | */
/* |  /========\  | **     Maurizio Sartori 'masar'     ** |  /========\  | */
/* |/   ======   \| **   e-mail:  masar@MasarLabs.com   ** |/   ======   \| */
/****************************************************************************/
/*              This program comes with ABSOLUTELY NO WARRANTY              */
/*            for details refer to the GNU General Public License           */
/****************************************************************************/
/*\F $Id: main.c,v 1.42 2003/06/13 14:36:48 cvs Exp $
*****************************************************************************/

static char Psz_RCS [] =
    "$Id: main.c,v 1.42 2003/06/13 14:36:48 cvs Exp $";

/****************************************************************************/

#include "msysm.h"
#include <msysm/modules.h>
#include "../xpm/dataMasar.xpm"

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <dlfcn.h>
#include <dirent.h>
#include <time.h>
#include <signal.h>

/****************************************************************************/
/*                             Global Variables                             */
/****************************************************************************/

Module * p_FirstModule = NULL;

static const char * ach_Version =
    "                    " APP_STR_NAME "  Ver "
    APP_STR_MAJOR "." APP_STR_MINOR "." APP_STR_REVIS "\n"
    "                " APP_STR_DESCR "\n";

static const char * ach_Copyright =
    "  Copyright " APP_STR_COPYRIGHT "\n"
    "  Written by " APP_STR_AUTHOR " <" APP_STR_EMAIL ">\n"
    "\n"
    "  This program is free software; you may redistribute \n"
    "  it under the terms of the GNU General Public License  \n"
    "  This program has absolutely no warranty\n";

/****************************************************************************/
/*                                 main ()                                  */
/****************************************************************************/
int main (int argc, const char * argv[])
   {
   int iRc;
   int iOk;

   Display * displayMain;
   Window    windowRoot;
   Window    windowMain;
   Window    windowPopUp;
   GC        gcMain;
   GC        gcPopUp;
   int       iScreen;

   Atom      wmDeleteWindow;
   Atom      wmProtocols;

   XSetWindowAttributes xWinAttr;
   unsigned long        ulAttrMask;
   int iX, iY, iXTmp, iYTmp;
   unsigned int uiWidth, uiHeight;
   XGCValues  xGcValues;
   XClassHint xClassHint;
   XSizeHints xSizeHints;
   XEvent     xEvent;
   Time       xButton1Time;
   Module    *pButton1Mod;
   char       pszKey [20];
   KeySym     keySym;
   Module    *pMod;
   Module    *pModPopUp = NULL;
   int        i, j, k;
   const char * pszLibPath = LIB_DIR;
   DIR      * pDir;
   struct dirent * dirEntry;
   const char * argv2[3];
   char achResName []  = "msysm";
   char achResClass [] = "MSYSM";
   const char * pBuffer;
   const char * pPtr;
   struct sigaction   sigAction;
   XpmIcon xpmMasarLogo;

   *Psz_RCS = *Psz_RCS;                 // To fake compiler warnings

   /*************************************************************************/
   /* Initialize                                                            */
   /*************************************************************************/
   srand ((unsigned) time (NULL));

   // Set signal handlers
   memset (&sigAction, 0, sizeof (sigAction));
   sigAction.sa_handler = SIG_IGN;
   sigemptyset (&sigAction.sa_mask);

   if (sigaction (SIGCHLD, &sigAction, NULL) == -1)
      {
      fprintf (stderr, "%s: Cannot set Signal\n", argv[0]);
      return (1);
      }

   // Create main window
   displayMain = XOpenDisplay (NULL);
   if (displayMain == NULL)
      {
      fprintf (stderr, "%s: can't open display %s\n",
               argv[0], XDisplayName (NULL));
      return (1);
      }

   windowRoot = DefaultRootWindow (displayMain);
   iScreen    = DefaultScreen (displayMain);

   xWinAttr.background_pixel  = BlackPixel (displayMain, iScreen);
   xWinAttr.border_pixel      = BlackPixel (displayMain, iScreen);
   xWinAttr.event_mask        = ExposureMask | KeyPressMask |
                                StructureNotifyMask |
                                ButtonPressMask | ButtonReleaseMask;
   xWinAttr.override_redirect = False;
   ulAttrMask = CWBackPixel | CWBorderPixel | CWEventMask | CWOverrideRedirect;

   windowMain = XCreateWindow (displayMain, windowRoot,
                                1, 1, 1, 1,
                                0, CopyFromParent, InputOutput, CopyFromParent,
                                ulAttrMask, &xWinAttr);
   if (windowMain == None)
      {
      fprintf (stderr, "%s: can't create the main window\n", argv[0]);
      return (2);
      }

   xWinAttr.background_pixel  = GetColor ("#333333", displayMain, windowRoot);
   xWinAttr.border_pixel      = GetColor ("#FFFF00", displayMain, windowRoot);
   xWinAttr.event_mask        = ExposureMask | ButtonReleaseMask;
   xWinAttr.override_redirect = True;
   xWinAttr.backing_store     = WhenMapped;
   xWinAttr.save_under        = True;
   ulAttrMask = CWBackPixel | CWBorderPixel | CWEventMask |
                CWBackingStore | CWSaveUnder | CWOverrideRedirect;

   // Create popup window
   windowPopUp = XCreateWindow (displayMain, windowRoot,
                                100, 100, 100, 100,
                                1, CopyFromParent, InputOutput, CopyFromParent,
                                ulAttrMask, &xWinAttr);
   if (windowPopUp == None)
      {
      fprintf (stderr, "%s: can't create the popup window\n", argv[0]);
      return (2);
      }

   xClassHint.res_name  = achResName;
   xClassHint.res_class = achResClass;
   XSetClassHint (displayMain, windowMain, &xClassHint);
   XStoreName (displayMain, windowMain,
               APP_STR_NAME " Ver "
               APP_STR_MAJOR "." APP_STR_MINOR "." APP_STR_REVIS);

   wmDeleteWindow = XInternAtom (displayMain, "WM_DELETE_WINDOW", False);
   wmProtocols    = XInternAtom (displayMain, "WM_PROTOCOLS",     False);
   iRc = XSetWMProtocols (displayMain, windowMain, &wmDeleteWindow, 1);

   // Create graphic context
   xGcValues.foreground         = WhitePixel (displayMain, iScreen);
   xGcValues.background         = BlackPixel (displayMain, iScreen);
   xGcValues.line_width         = 1;
   xGcValues.line_style         = LineSolid;
   xGcValues.fill_style         = FillSolid;
   xGcValues.graphics_exposures = False; // True;

   gcMain = XCreateGC (displayMain, windowMain,
                        GCForeground | GCBackground | GCLineWidth |
                        GCLineStyle  | GCFillStyle  | GCGraphicsExposures,
                        &xGcValues);
   XSetLineAttributes (displayMain, gcMain, 0, LineSolid, CapButt, JoinMiter);
   gcPopUp = XCreateGC (displayMain, windowPopUp,
                        GCForeground | GCBackground | GCLineWidth |
                        GCLineStyle  | GCFillStyle  | GCGraphicsExposures,
                        &xGcValues);
   XSetLineAttributes (displayMain, gcPopUp, 0, LineSolid, CapButt, JoinMiter);

   memset (&xpmMasarLogo, 0, sizeof (xpmMasarLogo));
   XpmCreatePixmapFromData (displayMain, windowPopUp,
                            (char **) dataMasar_xpm,
                             &xpmMasarLogo.pixmap,
                             &xpmMasarLogo.mask,
                             &xpmMasarLogo.attributes);

   /*************************************************************************/
   /* Parse Options and Load Modules                                        */
   /*************************************************************************/
   iX  = 100;
   iY  = 100;
   iOk = 1;
   i   = 1;
   while (i < argc)
      {
      if (!strcmp (argv[i], "-h") || !strcmp (argv[i], "--help"))
         {
         fprintf (stdout,
                  "usage: %s [options] [-m mod mod_opts] [-M mod mod_opts]\n"
                  "options:\n"
                  "   -h --help       : print this help\n"
                  "   -H --HELP       : print modules help\n"
                  "   -V --version    : print version and copyright\n"
                  "   -l --library    : modules path, use -V to see it\n"
                  "   -m --horizontal : add module to the right\n"
                  "   -M --vertical   : add module on a new line\n"
                  "   -p --position   : window position (es: +10+200)\n"
                  "mod: is module name, use -V to have a list\n"
                  "mod_opts: are module options, use -H to have a list\n",
                  argv[0]);
         iOk = 0;
         }
      else if (!strcmp (argv[i], "-H") || !strcmp (argv[i], "--HELP"))
         {
         pDir = opendir (pszLibPath);
         if (pDir)
            {
            argv2[1] = "+h";

            fprintf (stdout, "%s modules:\n", argv[0]);
            dirEntry = readdir (pDir);
            while (dirEntry)
               {
               j = strlen (dirEntry->d_name);

               if ((j > 3) &&
                   (dirEntry->d_name[j-3] == '.') &&
                   (dirEntry->d_name[j-2] == 's') &&
                   (dirEntry->d_name[j-1] == 'o'))
                  {
                  dirEntry->d_name[j-3] = 0;
                  argv2[0] = dirEntry->d_name;
                  LoadModule (2, argv2, pszLibPath, 0,
                              displayMain, windowMain);

                  fprintf (stdout, "\n");
                  }
               dirEntry = readdir (pDir);
               }
            closedir (pDir);
            }

         iOk = 0;
         }
      else if (!strcmp (argv[i], "-V") || !strcmp (argv[i], "--version"))
         {
         fprintf (stdout, "%s\n"
                  "  " APP_STR_NAME " Ver "
                  APP_STR_MAJOR "." APP_STR_MINOR "." APP_STR_REVIS " - "
                  APP_STR_DESCR "\n\n%s\n\n"
                  "   Library Path: %s\n",
                  argv[0], ach_Copyright, pszLibPath);

         pDir = opendir (pszLibPath);
         if (pDir)
            {
            argv2[1] = "+V";

            fprintf (stdout, "  Modules:\n");
            dirEntry = readdir (pDir);
            while (dirEntry)
               {
               j = strlen (dirEntry->d_name);

               if ((j > 3) &&
                   (dirEntry->d_name[j-3] == '.') &&
                   (dirEntry->d_name[j-2] == 's') &&
                   (dirEntry->d_name[j-1] == 'o'))
                  {
                  fprintf (stdout, "    ");

                  dirEntry->d_name[j-3] = 0;
                  argv2[0] = dirEntry->d_name;
                  LoadModule (2, argv2, pszLibPath, 0,
                              displayMain, windowMain);
                  }
               dirEntry = readdir (pDir);
               }
            closedir (pDir);
            }

         iOk = 0;
         }
      else if (!strcmp (argv[i], "-l") || !strcmp (argv[i], "--library"))
         {
         i++;
         if ((i < argc) && (argv[i][0] == '/'))
            {
            pszLibPath = argv[i];
            }
         else
            {
            i--;
            fprintf (stderr, "%s: %s requires the library full-pathname\n",
                     argv[0], argv[i]);
            iOk = 0;
            }
         }
      else if (!strcmp (argv[i], "-p") || !strcmp (argv[i], "--position"))
         {
         i++;
         if (i >= argc)
            {
            i--;
            fprintf (stderr, "%s: %s requires a position (es: +100+100)\n",
                     argv[0], argv[i]);
            iOk = 0;
            }
         else if (XParseGeometry (argv[i], &iX, &iY,
                                  &uiWidth, &uiHeight) != (XValue | YValue))
            {
            fprintf (stderr, "%s: %s has invalid parameter \"%s\"\n",
                     argv[0], argv[i-1], argv[i]);
            iOk = 0;
            }
         }
      else if (!strcmp (argv[i], "-m") || !strcmp (argv[i], "--horizontal") ||
               !strcmp (argv[i], "-M") || !strcmp (argv[i], "--vertical"))
         {
         int fVertical = !strcmp (argv[i], "-M") ||
                         !strcmp (argv[i], "--vertical");
         i++;
         k = i;
         while ((k < argc) && (argv[k][0] != '-'))
            {
            k++;
            }
         if (k > i)
            {
            iRc = LoadModule (k-i, &argv[i], pszLibPath, fVertical,
                              displayMain, windowMain);
            i = k - 1;
            }
         else
            {
            i--;
            fprintf (stderr, "%s: %s requires a module name\n",
                     argv[0], argv[i]);
            iOk = 0;
            }
         }
      else
         {
         fprintf (stderr, "%s: invalid parameter %s\n",
                  argv[0], argv[i]);
         iOk = 0;
         }
      i++;
      }

   if (!iOk)
      {
      UnLoadAllModules (displayMain, windowMain);
      return (1);
      }

   if (p_FirstModule == NULL)
      {
      fprintf (stderr, "%s: nothing to do !!\n", argv[0]);

      XDestroyWindow (displayMain, windowMain);
      XCloseDisplay (displayMain);
      return (1);
      }

   /*************************************************************************/
   /* Resize and Paint                                                      */
   /*************************************************************************/
   uiWidth  = 0;
   uiHeight = 0;

   pMod = p_FirstModule;
   while (pMod != NULL)
      {
      if (uiHeight < pMod->iY + pMod->uiHeight)
         {
         uiHeight = pMod->iY + pMod->uiHeight;
         }

      if (uiWidth < pMod->iX + pMod->uiWidth)
         {
         uiWidth = pMod->iX + pMod->uiWidth;
         }
      pMod = pMod->pNext;
      }

   if ((iX + uiWidth) > (unsigned) DisplayWidth (displayMain, iScreen))
      {
      fprintf (stderr, "%s: Correcting XPos from %i to %i\n",
               argv[0], iX,
               DisplayWidth (displayMain, iScreen) - uiWidth);
      iX = DisplayWidth (displayMain, iScreen) - uiWidth;
      }
   if (iX < 0)
      {
      fprintf (stderr, "%s: Correcting XPos from %i to 0\n",
               argv[0], iX);
      iX = 0;
      }

   if ((iY + uiHeight) > (unsigned) DisplayHeight (displayMain, iScreen))
      {
      fprintf (stderr, "%s: Correcting YPos from %i to %i\n",
               argv[0], iY,
               DisplayHeight (displayMain, iScreen) - uiHeight);
      iY = DisplayHeight (displayMain, iScreen) - uiHeight;
      }
   if (iY < 0)
      {
      fprintf (stderr, "%s: Correcting YPos from %i to 0\n",
               argv[0], iY);
      iY = 0;
      }

   xSizeHints.flags      = PMinSize | PMaxSize | PResizeInc ;
   xSizeHints.min_width  = uiWidth;              // No Resize !!
   xSizeHints.min_height = uiHeight;
   xSizeHints.max_width  = uiWidth;
   xSizeHints.max_height = uiHeight;
   xSizeHints.width_inc  = 0;
   xSizeHints.height_inc = 0;

   XMapWindow (displayMain, windowMain);
   XSetWMNormalHints (displayMain, windowMain, &xSizeHints);
   XMoveResizeWindow (displayMain, windowMain, iX, iY, uiWidth, uiHeight);

   XClearWindow (displayMain, windowMain);
   XFlush (displayMain);
   XSync (displayMain, False);

   /*************************************************************************/
   /* Start Processing Events                                               */
   /*************************************************************************/
   xButton1Time = 0;
   pButton1Mod  = NULL;
   iOk = 1;
   while (iOk)
      {
      /**********************************************************************/
      /* Update Modules                                                     */
      /**********************************************************************/
      pMod = p_FirstModule;
      while (pMod != NULL)
         {
         if (pMod->pfnUpdate (pMod->pModData))
            {
            pMod->pfnPaint (displayMain, windowMain, gcMain,
                            pMod->iX, pMod->iY,
                            pMod->pModData);
            }
         pMod = pMod->pNext;
         }

      /**********************************************************************/
      /* Process Events                                                     */
      /**********************************************************************/
      while (XPending (displayMain))
         {
         XNextEvent (displayMain, &xEvent);

//         fprintf (stderr, "xEvent.type = %i\n", xEvent.type);
         switch (xEvent.type)
            {
            /****************************************************************/
            /* Window Resize                                                */
            /****************************************************************/
            case ConfigureNotify:
               {
               iX       = xEvent.xconfigure.x;
               iY       = xEvent.xconfigure.y;
               uiWidth  = xEvent.xconfigure.width;
               uiHeight = xEvent.xconfigure.height;
               }
            // Fall trought

            /****************************************************************/
            /* Window Paint                                                 */
            /****************************************************************/
            case Expose:
               {
               if (xEvent.xexpose.window == windowMain)
                  {
                  /**********************************************************/
                  /* Main Window Paint                                      */
                  /**********************************************************/
                  pMod = p_FirstModule;
                  while (pMod != NULL)
                     {
                     pMod->pfnPaint (displayMain, windowMain, gcMain,
                                     pMod->iX, pMod->iY,
                                     pMod->pModData);
                     pMod = pMod->pNext;
                     }
                  }
               else if (xEvent.xexpose.window == windowPopUp)
                  {
                  /**********************************************************/
                  /* PopUp Window Paint                                     */
                  /**********************************************************/
//                  if (pModPopUp)
//                     {
//                     pBuffer = pModPopUp->pfnInfo (pModPopUp->pModData);
//                     DrawLetterString (pBuffer,
//                                       displayMain, windowPopUp,
//                                       gcPopUp, 3, 5);
//                     }
                  }
               else
                  {
                  fprintf (stderr, "Expose ?????\n");
                  }

               // Clear any further expose events from the queue
               while (XCheckTypedEvent (displayMain, Expose, &xEvent))
                  {
                  // NOP
                  }
               }
            break;

            /****************************************************************/
            /* Key Pressed                                                  */
            /****************************************************************/
            case KeyPress:
               {
               XLookupString (&xEvent.xkey, pszKey, 19, &keySym, NULL);
               pszKey[19] = 0;

               if (pszKey[0] == 'q' && pszKey[1] == 0)
                  {
                  iOk = 0;
                  }
               }
            break;

            /****************************************************************/
            /* Mouse Button Pressed                                         */
            /****************************************************************/
            case ButtonPress:
               {
               iXTmp = xEvent.xbutton.x;
               iYTmp = xEvent.xbutton.y;

               // Search module
               pMod = p_FirstModule;
               while ((pMod != NULL) &&
                      !((iYTmp >= pMod->iY) &&
                        ((unsigned) iYTmp <= pMod->iY + pMod->uiHeight) &&
                        (iXTmp >= pMod->iX) &&
                        ((unsigned) iXTmp <= pMod->iX + pMod->uiWidth)))
                  {
                  pMod = pMod->pNext;
                  }

               if (xEvent.xbutton.button == Button1)
                  {
                  /**********************************************************/
                  /* Mouse Button 1 Pressed                                 */
                  /**********************************************************/
                  if ((pMod != NULL) && (pMod == pButton1Mod) &&
                      (xEvent.xbutton.time - xButton1Time < 300))
                     {
                     /*******************************************************/
                     /* Mouse Button 1 Double Click                         */
                     /*******************************************************/
                     pMod->pfnExec (pMod->pModData);
                     }
                  xButton1Time = xEvent.xbutton.time;
                  pButton1Mod  = pMod;
                  }
               else if (xEvent.xbutton.button == Button2)
                  {
                  /**********************************************************/
                  /* Mouse Button 2 Pressed                                 */
                  /**********************************************************/
                  i = 1;
                  j = 8;
                  k = 1;
                  pPtr = ach_Copyright;
                  while (*pPtr)
                     {
                     if (*pPtr == '\n')
                        {
                        j++;
                        if (i > k)
                           {
                           k = i;
                           }
                        i = 0;
                        }
                     i++;
                     pPtr++;
                     }
                  if (i > k)
                     {
                     k = i;
                     }

                  k *= 6;
                  j *= 10;
                  iXTmp += iX - (k/2);
                  iYTmp += iY - (j/2);

                  if ((iXTmp + k + 2) >
                      DisplayWidth (displayMain, iScreen))
                     {
                     iXTmp = DisplayWidth (displayMain, iScreen) - k - 2;
                     }
                  if (iXTmp < 0)
                     {
                     iXTmp = 0;
                     }

                  if ((iYTmp + j + 2) >
                      DisplayHeight (displayMain, iScreen))
                     {
                     iYTmp = DisplayHeight (displayMain, iScreen) - j - 2;
                     }
                  if (iYTmp < 0)
                     {
                     iYTmp = 0;
                     }
                  XGrabPointer (displayMain, windowMain, True,
                                ButtonReleaseMask | PointerMotionMask,
                                GrabModeAsync, GrabModeAsync,
                                None, None, CurrentTime);
                  XMoveResizeWindow (displayMain, windowPopUp,
                                     iXTmp, iYTmp,
                                     (unsigned) k, (unsigned) j);
                  XMapRaised (displayMain, windowPopUp);
                  DrawLetterString (ach_Version,
                                    displayMain, windowPopUp,
                                    gcPopUp, 3, 5+10*1);
                  DrawLetterString (ach_Copyright,
                                    displayMain, windowPopUp,
                                    gcPopUp, 3, 5+10*6);
                  XCopyArea (displayMain, xpmMasarLogo.pixmap,
                             windowPopUp, gcPopUp,
                             0, 0,
                             xpmMasarLogo.attributes.width,
                             xpmMasarLogo.attributes.height,
                             3 + 6*5, 5+10*0);
                  XCopyArea (displayMain, xpmMasarLogo.pixmap,
                             windowPopUp, gcPopUp,
                             0, 0,
                             xpmMasarLogo.attributes.width,
                             xpmMasarLogo.attributes.height,
                             3 + 6*43, 5+10*0);
                  }
               else if (xEvent.xbutton.button == Button3)
                  {
                  /**********************************************************/
                  /* Mouse Button 3 Pressed                                 */
                  /**********************************************************/
                  if (pMod)
                     {
                     pModPopUp = pMod;
                     pBuffer = pModPopUp->pfnInfo (pModPopUp->pModData);
                     if (pBuffer)
                        {
                        i = 1;
                        j = 2;
                        k = 1;
                        pPtr = pBuffer;
                        while (*pPtr)
                           {
                           if (*pPtr == '\n')
                              {
                              j++;
                              if (i > k)
                                 {
                                 k = i;
                                 }
                              i = 0;
                              }
                           i++;
                           pPtr++;
                           }
                        if (i > k)
                           {
                           k = i;
                           }

                        k *= 6;
                        j *= 10;
                        iXTmp += iX - (k/2);
                        iYTmp += iY - (j/2);

                        if ((iXTmp + k + 2) >
                            DisplayWidth (displayMain, iScreen))
                           {
                           iXTmp = DisplayWidth (displayMain, iScreen) - k - 2;
                           }
                        if (iXTmp < 0)
                           {
                           iXTmp = 0;
                           }

                        if ((iYTmp + j + 2) >
                            DisplayHeight (displayMain, iScreen))
                           {
                           iYTmp = DisplayHeight (displayMain, iScreen) - j - 2;
                           }
                        if (iYTmp < 0)
                           {
                           iYTmp = 0;
                           }
                        XGrabPointer (displayMain, windowMain, True,
                                      ButtonReleaseMask | PointerMotionMask,
                                      GrabModeAsync, GrabModeAsync,
                                      None, None, CurrentTime);
                        XMoveResizeWindow (displayMain, windowPopUp,
                                           iXTmp, iYTmp,
                                           (unsigned) k, (unsigned) j);
                        XMapRaised (displayMain, windowPopUp);
                        DrawLetterString (pBuffer,
                                          displayMain, windowPopUp,
                                          gcPopUp, 3, 5);
                        }
                     }
                  }
               }
            break;

            /****************************************************************/
            /* Mouse Button Release                                         */
            /****************************************************************/
            case ButtonRelease:
               {
               if ((xEvent.xbutton.button == Button2) ||
                   (xEvent.xbutton.button == Button3))
                  {
                  XUnmapWindow (displayMain, windowPopUp);
                  XUngrabPointer (displayMain, CurrentTime);
                  pModPopUp = NULL;
                  }
//               fprintf (stderr, "Button Release\n");
               }
            break;

            /****************************************************************/
            /* Window Messages                                              */
            /****************************************************************/
            case ClientMessage:
               {
               if ((xEvent.xclient.message_type == wmProtocols) &&
                   ((Atom) xEvent.xclient.data.l[0] == wmDeleteWindow))
                  {
                  iOk = 0;
                  }
               }
            break;
            }
         }
      /**********************************************************************/
      /* Sleep                                                              */
      /**********************************************************************/
      usleep (100000);       // time is in microseconds (1/1000000 of sec)
      }

   /*************************************************************************/
   /* Destroy All and exit                                                  */
   /*************************************************************************/
   UnLoadAllModules (displayMain, windowMain);

   XDestroyWindow (displayMain, windowMain);
   XCloseDisplay (displayMain);

   return (0);
   } /* End of main */

