/****************************************************************************/
/* |\   ======   /| **              MSysM               ** |\   ======   /| */
/* |__\========/__| **     MasarLabs System Monitor     ** |__\========/__| */
/* |\            /| ** -------------------------------- ** |\            /| */
/* |  \        /  | **  Maurizio Sartori (c) 1998-2000  ** |  \        /  | */
/* |    \    /    | ** -------------------------------- ** |    \    /    | */
/* |    /=\/=\    | **            Written  by           ** |    /=\/=\    | */
/* |  /========\  | **     Maurizio Sartori 'masar'     ** |  /========\  | */
/* |/   ======   \| **   e-mail:  masar@MasarLabs.com   ** |/   ======   \| */
/****************************************************************************/
/*              This program comes with ABSOLUTELY NO WARRANTY              */
/*            for details refer to the GNU General Public License           */
/****************************************************************************/
/*\F $Id: mail.c,v 1.18 2003/11/19 15:11:13 cvs Exp $
*****************************************************************************/

static char Psz_RCS [] =
    "$Id: mail.c,v 1.18 2003/11/19 15:11:13 cvs Exp $";

/****************************************************************************/

#include <msysm/modules.h>
#include "dataMail.xpm"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <dirent.h>

#define MOD_MAX_COUNT   (100)
#define MAIL_PRG        "x-terminal-emulator -e mail"

/****************************************************************************/
/* Local Types                                                              */
/****************************************************************************/
typedef struct _ModuleData
   {
   int           iCount;
   XpmIcon       xpmBGrnd;
   Pixel         pxRed;
   Pixel         pxGreen;
   char          achMailBox[MAXPATHLEN+1];
   char          achMailCmd[MAXPATHLEN+1];
   int           iTotal;
   int           iUnread;
   int           iNew;
   int           iBeep;
   time_t        timeFile;
   time_t        timeFile2;
   char          achMessage[255];
   } ModuleData;

/****************************************************************************/
/*                                  Load ()                                 */
/****************************************************************************/
static int countMBox (ModuleData * pModData, const struct stat * pStat)
   {
   FILE * fileIn;
   char chTmp;
   const char * pszFrom   = "\nFrom ";
   int iFrom;
   const char * pszStatus = "\nStatus: ";
   int iStatus;
   int iTotal;
   int iRead;
   int iOld;

   if (pStat->st_ctime == pModData->timeFile)
      {
      return (0);
      }

   pModData->timeFile = pStat->st_ctime;

   fileIn = fopen (pModData->achMailBox, "r");
   if (fileIn == NULL)
      {
      return (0);
      }

   iTotal  = 0;
   iRead   = 0;
   iOld    = 0;
   iFrom   = 1;         /* Skipp first '\n' */
   iStatus = 0;
   chTmp = fgetc (fileIn);
   while (!feof (fileIn) && !ferror (fileIn))
      {
      if (chTmp == pszFrom[iFrom])
         {
         ++iFrom;
         if (pszFrom[iFrom] == 0)
            {
            ++iTotal;
            iFrom = 0;
            }
         }
      else if (chTmp == '\n')
         {
         iFrom = 1;
         }
      else
         {
         iFrom = 0;
         }

      if (pszStatus[iStatus] == 0)
         {
         if (chTmp == 'R')
            {
            ++iRead;
            }
         else if (chTmp == 'O')
            {
            ++iOld;
            }
         else if (chTmp == '\n')
            {
            iStatus = 1;
            }
         }
      else if (chTmp == pszStatus[iStatus])
         {
         ++iStatus;
         }
      else
         {
         iStatus = 0;
         }

      chTmp = fgetc (fileIn);
      }
   fclose (fileIn);

   if ((pModData->iTotal < iTotal) &&
       (pModData->iTotal != 0))
      {
      pModData->iBeep = 1;
      }

   pModData->iTotal  = iTotal;
   pModData->iUnread = iTotal - iRead;
   pModData->iNew    = iTotal - iOld;

   return (1);
   }

/****************************************************************************/
/*                                  Load ()                                 */
/****************************************************************************/
static int countMaildir (ModuleData * pModData,
                         const struct stat * pStat)
   {
   char achMaildir[MAXPATHLEN+1];
   struct stat statNew;
   struct stat statCur;
   DIR *pDir;
   struct dirent *pDirEnt;
   int iTotal;
   int iRead;
   int iNew;
   int iLen;

   pStat = NULL;
   strncpy (achMaildir, pModData->achMailBox, MAXPATHLEN-4);
   achMaildir[MAXPATHLEN-4] = 0;
   strcat (achMaildir, "/new");
   if (stat (achMaildir, &statNew))
      {
      return (0);
      }

   strncpy (achMaildir, pModData->achMailBox, MAXPATHLEN-4);
   achMaildir[MAXPATHLEN-4] = 0;
   strcat (achMaildir, "/cur");
   if (stat (achMaildir, &statCur))
      {
      return (0);
      }

   if ((statNew.st_ctime == pModData->timeFile) &&
       (statCur.st_ctime == pModData->timeFile2))
      {
      return (0);
      }

   pModData->timeFile  = statNew.st_ctime;
   pModData->timeFile2 = statCur.st_ctime;

   iTotal  = 0;
   iRead   = 0;
   iNew    = 0;

   strncpy (achMaildir, pModData->achMailBox, MAXPATHLEN-4);
   achMaildir[MAXPATHLEN-4] = 0;
   strcat (achMaildir, "/new");
   pDir = opendir (achMaildir);
   if (pDir == NULL)
      {
      return 0;
      }

   pDirEnt = readdir (pDir);
   while (pDirEnt != NULL)
      {
      if (pDirEnt->d_name[0] != '.')
         {
         ++iTotal;
         ++iNew;
         }
      pDirEnt = readdir (pDir);
      }
   closedir (pDir);

   strncpy (achMaildir, pModData->achMailBox, MAXPATHLEN-4);
   achMaildir[MAXPATHLEN-4] = 0;
   strcat (achMaildir, "/cur");
   pDir = opendir (achMaildir);
   if (pDir == NULL)
      {
      return 0;
      }

   pDirEnt = readdir (pDir);
   while (pDirEnt != NULL)
      {
      if (pDirEnt->d_name[0] != '.')
         {
         ++iTotal;
         iLen = strlen (pDirEnt->d_name);
         while ((iLen > 0) && (pDirEnt->d_name[iLen] != ','))
            {
            if (pDirEnt->d_name[iLen] == 'S')
               {
               ++iRead;
               }
            --iLen;
            }
         }
      pDirEnt = readdir (pDir);
      }
   closedir (pDir);

   pModData->iTotal  = iTotal;
   pModData->iUnread = iTotal - iRead;
   pModData->iNew    = iNew;

   return (1);
   }

/****************************************************************************/
/*                                  Load ()                                 */
/****************************************************************************/
void * Load (int argc, const char * argv [],
             Display * pDisplay, Window hWindow)
   {
   ModuleData * pModData;
   int iRc;
   int i;
   const char * pszMailBox;
   const char * pszMailCmd = MAIL_PRG;

   *Psz_RCS = *Psz_RCS;                         // To fake compiler warnings

   pszMailBox = NULL;
   iRc = 0;
   i = 1;
   while (i < argc)
      {
      if (!strcmp (argv[i], "+h") || !strcmp (argv[i], "++help"))
         {
         fprintf (stdout,
                  "usage: %s [options]\n"
                  "options:\n"
                  "   +h ++help           : print this help\n"
                  "   +V ++version        : print version\n"
                  "   +m ++mailbox <file> : mailbox path\n"
                  "   +r ++reader  <cmd>  : mail reader command\n",
                  argv[0]);
         iRc = 1;
         }
      else if (!strcmp (argv[i], "+V") || !strcmp (argv[i], "++version"))
         {
         char achRev [] = "$Revision: 1.18 $";
         achRev[strlen(achRev)-1] = '\0';

         fprintf (stdout, "%-10s Ver "
                  APP_STR_MAJOR "." APP_STR_MINOR "." APP_STR_REVIS
                  " Rev %s\n", argv[0], achRev + 11);
         iRc = 1;
         }
      else if (!strcmp (argv[i], "+m") || !strcmp (argv[i], "++mailbox"))
         {
         ++i;
         if (i == argc)
            {
            fprintf (stderr, "%s: mailbox path is required\n", argv[0]);
            return (NULL);
            }
         pszMailBox = argv[i];
         }
      else if (!strcmp (argv[i], "+r") || !strcmp (argv[i], "++reader"))
         {
         ++i;
         if (i == argc)
            {
            fprintf (stderr, "%s: reader command is required\n", argv[0]);
            return (NULL);
            }
         pszMailCmd = argv[i];
         }
      else
         {
         fprintf (stderr, "%s: invalid parameter %s\n", argv[0], argv[i]);
         iRc = 1;
         }
      i++;
      }

   if (iRc)
      {
      return (NULL);
      }

   pModData = (ModuleData *) malloc (sizeof (ModuleData));
   if (pModData == NULL)
      {
      return (NULL);
      }

   pModData->iCount        = MOD_MAX_COUNT;
   pModData->pxRed         = GetColor ("#FF0000", pDisplay, hWindow);
   pModData->pxGreen       = GetColor ("#00FF00", pDisplay, hWindow);
   pModData->achMailBox[0] = 0;
   pModData->iTotal        = 0;
   pModData->iUnread       = 0;
   pModData->iNew          = 0;
   pModData->iBeep         = 0;
   pModData->timeFile      = 0;
   pModData->timeFile2     = 0;

   if (pszMailBox == NULL)
      {
      pszMailBox = getenv ("MAIL");
      }

   if (pszMailBox)
      {
      strncpy (pModData->achMailBox, pszMailBox,
               sizeof (pModData->achMailBox));
      pModData->achMailBox[sizeof(pModData->achMailBox)] = 0;
      }

   if (pszMailCmd)
      {
      strncpy (pModData->achMailCmd, pszMailCmd,
               sizeof (pModData->achMailCmd));
      pModData->achMailCmd[sizeof(pModData->achMailCmd)] = 0;
      }

   memset (&pModData->xpmBGrnd, 0, sizeof (pModData->xpmBGrnd));
   pModData->xpmBGrnd.attributes.valuemask = (XpmReturnPixels |
                                              XpmReturnExtensions);

   XpmCreatePixmapFromData (pDisplay, hWindow,
                            (char **) dataMail_xpm,
                            &pModData->xpmBGrnd.pixmap,
                            &pModData->xpmBGrnd.mask,
                            &pModData->xpmBGrnd.attributes);

   Update (pModData);
   pModData->iCount = rand () % MOD_MAX_COUNT;

   return (pModData);
   }

/****************************************************************************/
/*                                 UnLoad ()                                */
/****************************************************************************/
void UnLoad (void * pData, Display * pDisplay, Window hWindow)
   {
   ModuleData * pModData = (ModuleData *) pData;
   (void) hWindow;

   XFreePixmap (pDisplay, pModData->xpmBGrnd.pixmap);
   free (pModData);
   }

/****************************************************************************/
/*                                 Update ()                                */
/****************************************************************************/
int Update (void * pData)
   {
   ModuleData * pModData = (ModuleData *) pData;
   struct stat statNew;

   pModData->iCount++;
   if (pModData->iCount < MOD_MAX_COUNT)
      {
      return (0);
      }
   pModData->iCount = 0;

   if (!pModData->achMailBox[0] ||
       stat (pModData->achMailBox, &statNew))
      {
      return (0);
      }

   if (S_ISDIR (statNew.st_mode))
      {
      return countMaildir (pModData, &statNew);
      }

   return countMBox (pModData, &statNew);
   }

/****************************************************************************/
/*                                 Paint ()                                 */
/****************************************************************************/
void Paint (Display * pDisplay, Window hWindow,
            GC        hGC, int iX, int iY,
            void    * pData)
   {
   int iRc;
   int  iLen;
   char achBuffer [5];
   int iVal;
   ModuleData * pModData = (ModuleData *) pData;
   XGCValues gcVal;

   iRc = XCopyArea (pDisplay, pModData->xpmBGrnd.pixmap, hWindow, hGC,
                    0, 0,
                    pModData->xpmBGrnd.attributes.width,
                    pModData->xpmBGrnd.attributes.height,
                    iX, iY);

   iLen = sizeof (achBuffer);
   achBuffer [iLen--] = 0;
   iVal = pModData->iTotal;
   while (iLen >= 0)
      {
      achBuffer [iLen--] = (iVal % 10) + '0';
      iVal /= 10;
      }
   iLen = 0;
   while (((size_t) iLen < (sizeof (achBuffer) - 1)) &&
          (achBuffer [iLen] == '0'))
      {
      achBuffer [iLen++] = ' ';
      }
   DrawDigitString (achBuffer, pDisplay, hWindow, hGC, iX + 18, iY + 12, 0);

   iLen = sizeof (achBuffer);
   achBuffer [iLen--] = 0;
   iVal = pModData->iUnread;
   while (iLen >= 0)
      {
      achBuffer [iLen--] = (iVal % 10) + '0';
      iVal /= 10;
      }
   iLen = 0;
   while (((size_t) iLen < (sizeof (achBuffer) - 1)) &&
          (achBuffer [iLen] == '0'))
      {
      achBuffer [iLen++] = ' ';
      }
   DrawDigitString (achBuffer, pDisplay, hWindow, hGC, iX + 18, iY + 22, 0);

   if (pModData->iBeep)
      {
      XBell (pDisplay, 100);
      pModData->iBeep = 0;
      }

   if (pModData->iUnread)
      {
      gcVal.foreground = pModData->pxRed;
      XChangeGC (pDisplay, hGC, GCForeground, &gcVal);

      XDrawLine (pDisplay, hWindow, hGC, iX + 26, iY + 3, iX + 38, iY + 3);
      XDrawLine (pDisplay, hWindow, hGC, iX + 25, iY + 4, iX + 25, iY + 4);
      XDrawLine (pDisplay, hWindow, hGC, iX + 27, iY + 4, iX + 37, iY + 4);
      XDrawLine (pDisplay, hWindow, hGC, iX + 39, iY + 4, iX + 39, iY + 4);
      XDrawLine (pDisplay, hWindow, hGC, iX + 25, iY + 5, iX + 26, iY + 5);
      XDrawLine (pDisplay, hWindow, hGC, iX + 28, iY + 5, iX + 36, iY + 5);
      XDrawLine (pDisplay, hWindow, hGC, iX + 38, iY + 5, iX + 39, iY + 5);
      XDrawLine (pDisplay, hWindow, hGC, iX + 25, iY + 6, iX + 27, iY + 6);
      XDrawLine (pDisplay, hWindow, hGC, iX + 29, iY + 6, iX + 35, iY + 6);
      XDrawLine (pDisplay, hWindow, hGC, iX + 37, iY + 6, iX + 39, iY + 6);
      XDrawLine (pDisplay, hWindow, hGC, iX + 25, iY + 7, iX + 27, iY + 7);
      XDrawLine (pDisplay, hWindow, hGC, iX + 30, iY + 7, iX + 34, iY + 7);
      XDrawLine (pDisplay, hWindow, hGC, iX + 37, iY + 7, iX + 39, iY + 7);
      XDrawLine (pDisplay, hWindow, hGC, iX + 25, iY + 8, iX + 26, iY + 8);
      XDrawLine (pDisplay, hWindow, hGC, iX + 28, iY + 8, iX + 29, iY + 8);
      XDrawLine (pDisplay, hWindow, hGC, iX + 35, iY + 8, iX + 36, iY + 8);
      XDrawLine (pDisplay, hWindow, hGC, iX + 38, iY + 8, iX + 39, iY + 8);
      XDrawLine (pDisplay, hWindow, hGC, iX + 25, iY + 9, iX + 25, iY + 9);
      XDrawLine (pDisplay, hWindow, hGC, iX + 27, iY + 9, iX + 37, iY + 9);
      XDrawLine (pDisplay, hWindow, hGC, iX + 39, iY + 9, iX + 39, iY + 9);
      XDrawLine (pDisplay, hWindow, hGC, iX + 26, iY +10, iX + 38, iY +10);
      }
   }

/****************************************************************************/
/*                                 Info ()                                  */
/****************************************************************************/
const char * Info (void * pData)
   {
   static char achRev [] = "$Revision: 1.18 $";
   ModuleData * pModData = (ModuleData *) pData;

   if (achRev[strlen (achRev)-1] == '$')
      {
      achRev[strlen (achRev)-1] = 0;
      }

   snprintf (pModData->achMessage,
             sizeof(pModData->achMessage),
             " mail  V %s\n"
             "\n"
             "Total  %i\nUnread %i\nNew    %i",
             achRev + 11,
             pModData->iTotal, pModData->iUnread, pModData->iNew);

   return (pModData->achMessage);
   }

/****************************************************************************/
/*                                 Exec ()                                  */
/****************************************************************************/
void Exec (void * pData)
   {
   ModuleData * pModData = (ModuleData *) pData;
   pid_t pid;
   const char * argv[4];

   (void) pModData;             /* Do Nothing !!                            */
   pid = fork();

   if (pid < 0)
      {
      fprintf (stderr, "msysm: mail.so cannot fork\n");
      return;
      }
   if (pid == 0)
      {
      argv[0] = "/bin/sh";
      argv[1] = "-c";
      argv[2] = pModData->achMailCmd;
      argv[3] = NULL;
      execv ("/bin/sh", (char **) argv);
      exit (1);
      }
   return;
   }

